Index: /code/trunk/src/libraries/core/command/ArgumentCompletionFunctions.h
===================================================================
--- /code/trunk/src/libraries/core/command/ArgumentCompletionFunctions.h	(revision 11051)
+++ /code/trunk/src/libraries/core/command/ArgumentCompletionFunctions.h	(revision 11052)
@@ -161,6 +161,6 @@
 */
 #define ARGUMENT_COMPLETION_FUNCTION_DECLARATION(functionname) \
-    _CoreExport ArgumentCompleter* functionname(); \
-    _CoreExport ArgumentCompletionList acf_##functionname
+    ArgumentCompleter* functionname(); \
+    ArgumentCompletionList acf_##functionname
 
 /**
@@ -196,14 +196,14 @@
     namespace autocompletion
     {
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(fallback)();
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(groupsandcommands)(const std::string& fragment);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(subcommands)(const std::string& fragment, const std::string& group);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(command)(const std::string& fragment);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(hiddencommand)(const std::string& fragment);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(files)(const std::string& fragment);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingssections)();
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingsentries)(const std::string& fragment, const std::string& section);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingsvalue)(const std::string& fragment, const std::string& entry, const std::string& section);
-        ARGUMENT_COMPLETION_FUNCTION_DECLARATION(tclthreads)();
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(fallback)();
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(groupsandcommands)(const std::string& fragment);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(subcommands)(const std::string& fragment, const std::string& group);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(command)(const std::string& fragment);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(hiddencommand)(const std::string& fragment);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(files)(const std::string& fragment);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingssections)();
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingsentries)(const std::string& fragment, const std::string& section);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(settingsvalue)(const std::string& fragment, const std::string& entry, const std::string& section);
+        _CoreExport ARGUMENT_COMPLETION_FUNCTION_DECLARATION(tclthreads)();
     }
 }
Index: /code/trunk/src/libraries/core/input/KeyBinder.cc
===================================================================
--- /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 11051)
+++ /code/trunk/src/libraries/core/input/KeyBinder.cc	(revision 11052)
@@ -359,4 +359,44 @@
     /**
     @brief
+        Return the first key name for a specific command in a human readable form
+    */
+    const std::string& KeyBinder::getBindingReadable(const std::string& commandName)
+    {
+        const std::string& binding = this->getBinding(commandName);
+
+        SubString substring = SubString(binding, ".");
+        std::string name;
+        std::string group;
+        switch(substring.size())
+        {
+            case 0:
+                return binding;
+            case 1:
+                return binding;
+            case 2:
+                group = substring[0];
+            default:
+                name = substring.subSet(1).join(".");
+        }
+
+        std::stringstream stream;
+        if(group.compare("Keys") == 0)
+            stream << "Key " << name.substr(3);
+        else if(group.compare("MouseButtons") == 0)
+            stream << "Mouse " << name;
+        else if(group.compare("JoyStickButtons") == 0)
+            stream << "Joystick " << name;
+        else if(group.compare("JoyStickAxes") == 0)
+            stream << "Joystick Axis" << name.substr(5, 6) << name.substr(name.find("Axis")+6);
+        else if(group.compare("MouseAxes") == 0)
+            stream << "Mouse " << name.substr(1,3) << " " << name.substr(0, 1) << "-Axis";
+        else
+            return binding;
+
+        return *(new std::string(stream.str()));
+    }
+
+    /**
+    @brief
         Get the number of different key bindings of a specific command.
     @param commandName
Index: /code/trunk/src/libraries/core/input/KeyBinder.h
===================================================================
--- /code/trunk/src/libraries/core/input/KeyBinder.h	(revision 11051)
+++ /code/trunk/src/libraries/core/input/KeyBinder.h	(revision 11052)
@@ -68,4 +68,5 @@
         const std::string& getBinding(const std::string& commandName); //tolua_export
         const std::string& getBinding(const std::string& commandName, unsigned int index); //tolua_export
+        const std::string& getBindingReadable(const std::string& commandName); //tolua_export
         unsigned int getNumberOfBindings(const std::string& commandName); //tolua_export
 
Index: /code/trunk/src/libraries/tools/ParticleInterface.cc
===================================================================
--- /code/trunk/src/libraries/tools/ParticleInterface.cc	(revision 11051)
+++ /code/trunk/src/libraries/tools/ParticleInterface.cc	(revision 11052)
@@ -233,3 +233,8 @@
             this->particleSystem_->setKeepParticlesInLocalSpace(keep);
     }
+
+    void ParticleInterface::setDimensions(float scale)
+    {
+        this->particleSystem_->setDefaultDimensions(scale * this->particleSystem_->getDefaultWidth(), scale * this->particleSystem_->getDefaultHeight());
+    }
 }
Index: /code/trunk/src/libraries/tools/ParticleInterface.h
===================================================================
--- /code/trunk/src/libraries/tools/ParticleInterface.h	(revision 11051)
+++ /code/trunk/src/libraries/tools/ParticleInterface.h	(revision 11052)
@@ -75,4 +75,6 @@
             void setDetailLevel(unsigned int level);
 
+            void setDimensions(float scale);
+
         protected:
             virtual void changedTimeFactor(float factor_new, float factor_old);
Index: /code/trunk/src/libraries/util/Math.cc
===================================================================
--- /code/trunk/src/libraries/util/Math.cc	(revision 11051)
+++ /code/trunk/src/libraries/util/Math.cc	(revision 11052)
@@ -161,5 +161,5 @@
          - If the other object is exactly above me, the function returns <tt>Vector2(0, 0.5)</tt>.
     */
-    orxonox::Vector2 get2DViewcoordinates(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition)
+    orxonox::Vector2 get2DViewCoordinates(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition)
     {
         orxonox::Vector3 distance = otherposition - myposition;
Index: /code/trunk/src/libraries/util/Math.h
===================================================================
--- /code/trunk/src/libraries/util/Math.h	(revision 11051)
+++ /code/trunk/src/libraries/util/Math.h	(revision 11052)
@@ -91,5 +91,5 @@
     _UtilExport float getAngle(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& otherposition);
     _UtilExport orxonox::Vector2 get2DViewdirection(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition);
-    _UtilExport orxonox::Vector2 get2DViewcoordinates(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition);
+    _UtilExport orxonox::Vector2 get2DViewCoordinates(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition);
     _UtilExport orxonox::Vector2 get3DProjection(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition, const float mapangle, const float detectionlimit);
     _UtilExport bool isObjectHigherThanShipOnMap(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition, const float mapangle);
Index: /code/trunk/src/modules/CMakeLists.txt
===================================================================
--- /code/trunk/src/modules/CMakeLists.txt	(revision 11051)
+++ /code/trunk/src/modules/CMakeLists.txt	(revision 11052)
@@ -43,2 +43,3 @@
 ADD_SUBDIRECTORY(mini4dgame)
 ADD_SUBDIRECTORY(dodgerace)
+ADD_SUBDIRECTORY(hover)
Index: /code/trunk/src/modules/docking/DockingController.cc
===================================================================
--- /code/trunk/src/modules/docking/DockingController.cc	(revision 11051)
+++ /code/trunk/src/modules/docking/DockingController.cc	(revision 11052)
@@ -61,5 +61,5 @@
 
         float distance = (this->dock_->getWorldPosition() - entity->getPosition()).length();
-        Vector2 coord = get2DViewcoordinates(     // I don't understand this too
+        Vector2 coord = get2DViewCoordinates(     // I don't understand this too
             entity->getPosition(),
             entity->getOrientation() * WorldEntity::FRONT,
Index: /code/trunk/src/modules/dodgerace/DodgeRace.cc
===================================================================
--- /code/trunk/src/modules/dodgerace/DodgeRace.cc	(revision 11051)
+++ /code/trunk/src/modules/dodgerace/DodgeRace.cc	(revision 11052)
@@ -71,8 +71,12 @@
             for (int i = 0; i < 7; i++)
             {
-                BigExplosion* chunk = new BigExplosion(this->center_->getContext());
-                chunk->setPosition(Vector3(600, 0, 100.f * i - 300));
-                chunk->setVelocity(Vector3(1000, 0, 0));  //player->getVelocity()
-                chunk->setScale(20);
+                WeakPtr<ExplosionPart> chunk5 = new ExplosionPart(this->center_->getContext());
+                chunk5->setPosition(Vector3(600, 0, 100.f * i - 300));
+                chunk5->setVelocity(Vector3(1000, 0, 0));  //player->getVelocity()
+                chunk5->setScale(10);
+                chunk5->setEffect1("Orxonox/explosion2b");
+                chunk5->setEffect2("Orxonox/smoke6");
+                chunk5->Explode();
+
             }
         }
Index: /code/trunk/src/modules/dodgerace/DodgeRace.h
===================================================================
--- /code/trunk/src/modules/dodgerace/DodgeRace.h	(revision 11051)
+++ /code/trunk/src/modules/dodgerace/DodgeRace.h	(revision 11052)
@@ -56,5 +56,4 @@
 
 #include "core/command/ConsoleCommand.h"
-#include "worldentities/BigExplosion.h"
 
 #include "gametypes/Deathmatch.h"
Index: /code/trunk/src/modules/hover/CMakeLists.txt
===================================================================
--- /code/trunk/src/modules/hover/CMakeLists.txt	(revision 11052)
+++ /code/trunk/src/modules/hover/CMakeLists.txt	(revision 11052)
@@ -0,0 +1,20 @@
+SET_SOURCE_FILES(Hover_SRC_FILES
+  Hover.cc
+  HoverShip.cc
+  HoverWall.cc
+  HoverOrigin.cc
+  HoverFlag.cc
+  TimeHUD.cc
+  FlagHUD.cc
+  MazeGenerator.cc
+)
+
+ORXONOX_ADD_LIBRARY(hover
+  PLUGIN
+  FIND_HEADER_FILES
+  LINK_LIBRARIES
+    orxonox
+    objects
+    overlays
+  SOURCE_FILES ${Hover_SRC_FILES}
+)
Index: /code/trunk/src/modules/hover/FlagHUD.cc
===================================================================
--- /code/trunk/src/modules/hover/FlagHUD.cc	(revision 11052)
+++ /code/trunk/src/modules/hover/FlagHUD.cc	(revision 11052)
@@ -0,0 +1,106 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+/**
+    @file FlagHUD.cc
+    @brief Implementation of the FlagHUD
+*/
+
+#include "FlagHUD.h"
+
+#include <OgreOverlayManager.h>
+#include <OgreMaterialManager.h>
+#include <OgrePanelOverlayElement.h>
+
+#include "util/StringUtils.h"
+#include "core/CoreIncludes.h"
+#include "Hover.h"
+
+namespace orxonox
+{
+    RegisterClass(FlagHUD);
+
+    FlagHUD::FlagHUD(Context* context) : OrxonoxOverlay(context)
+    {
+        RegisterObject(FlagHUD);
+
+        this->hoverGame_ = NULL;
+        this->panel_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
+            .createOverlayElement("Panel", "FlagHUD_Panel_" + getUniqueNumberString()));
+        this->panel_->setMaterialName("Hover/Flag");
+        this->overlay_->add2D(this->panel_);
+
+        this->flagCount_ = 5;
+        setFlagCount(5);
+    }
+
+    FlagHUD::~FlagHUD()
+    {
+        if (this->isInitialized())
+        {
+            Ogre::OverlayManager::getSingleton().destroyOverlayElement(this->panel_);
+        }
+    }
+
+/**
+    @brief Sets the amount of flags displayed, once zero it does not reappear
+    @param flagCount
+*/
+    void FlagHUD::setFlagCount(int flagCount) {
+        if(flagCount == 0){
+            this->panel_->hide();
+            return;
+        }
+        this->panel_->setDimensions(
+            this->panel_->_getRelativeWidth() / ((float) flagCount_) * ((float) flagCount),
+            this->panel_->_getRelativeHeight()
+            );
+        this->panel_->setTiling(flagCount*1.0f, 1.0f);
+
+        this->flagCount_ = flagCount;
+    }
+
+    void FlagHUD::tick(float dt)
+    {
+        SUPER(FlagHUD, tick, dt);
+
+        setFlagCount(this->hoverGame_->getNumberOfFlags());
+    }
+
+    void FlagHUD::changedOwner()
+    {
+        SUPER(FlagHUD, changedOwner);
+
+        if (this->getOwner() && this->getOwner()->getGametype())
+        {
+            this->hoverGame_ = orxonox_cast<Hover*>(this->getOwner()->getGametype());
+        }
+        else
+        {
+            this->hoverGame_ = 0;
+        }
+    }
+}
Index: /code/trunk/src/modules/hover/FlagHUD.h
===================================================================
--- /code/trunk/src/modules/hover/FlagHUD.h	(revision 11052)
+++ /code/trunk/src/modules/hover/FlagHUD.h	(revision 11052)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Cyrill Burgener
+ *
+ */
+
+ /**
+    @file FlagHUD.h
+    @brief Declaration of the FlagHUD class.
+*/
+
+#ifndef _FlagHUD_H__
+#define _FlagHUD_H__
+
+#include "HoverPrereqs.h"
+
+#include "util/OgreForwardRefs.h"
+#include "overlays/OrxonoxOverlay.h"
+#include "tools/interfaces/Tickable.h"
+
+namespace orxonox
+{
+    class _HoverExport FlagHUD : public OrxonoxOverlay , public Tickable
+    {
+    public:
+        FlagHUD(Context* context);
+        virtual ~FlagHUD();
+
+        virtual void tick(float dt);
+        virtual void changedOwner();
+
+        void setFlagCount(int flagCount);
+
+    private:
+        Hover* hoverGame_;
+        Ogre::PanelOverlayElement* panel_;
+        int flagCount_;
+    };
+}
+#endif /* _FlagHUD_H__ */
Index: /code/trunk/src/modules/hover/Hover.cc
===================================================================
--- /code/trunk/src/modules/hover/Hover.cc	(revision 11052)
+++ /code/trunk/src/modules/hover/Hover.cc	(revision 11052)
@@ -0,0 +1,115 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Manuel Meier
+ *   Co-authors:
+ *      Cyrill Burgener
+ *
+ */
+
+/**
+    @file Hover.cc
+    @brief Implementation of the Hover class. Sets up the whole Minigame
+*/
+
+#include "Hover.h"
+
+#include "HoverOrigin.h"
+#include "HoverWall.h"
+#include "HoverFlag.h"
+#include "MazeGenerator.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    RegisterUnloadableClass(Hover);
+
+    Hover::Hover(Context* context) : Gametype(context)
+    {
+        RegisterObject(Hover);
+
+        this->origin_ = NULL;
+        this->numberOfFlags_ = 1;
+        this->firstTick_ = true;
+
+        this->setHUDTemplate("HoverHUD");
+    }
+
+    void Hover::tick(float dt)
+    {
+        SUPER(Hover, tick, dt);
+
+        if(this->firstTick_ && this->origin_)
+        {
+            this->firstTick_ = false;
+
+            int numCells = this->origin_->getNumCells();
+            int cellSize = this->origin_->getCellSize();
+            int cellHeight = this->origin_->getCellHeight();
+
+            MazeGenerator generator(numCells);
+            generator.generateMaze();
+            generator.renderMaze();
+
+            int* levelcode = generator.getLevelcode();
+
+            //Outer Walls
+            for(int i = 0; i<numCells; i++){
+                (new HoverWall(origin_->getContext()))->init(0,        i+1,      cellSize, cellHeight, 1);
+                (new HoverWall(origin_->getContext()))->init(numCells, i+1,      cellSize, cellHeight, 1);
+                (new HoverWall(origin_->getContext()))->init(i+1,      0,        cellSize, cellHeight, 2);
+                (new HoverWall(origin_->getContext()))->init(i+1,      numCells, cellSize, cellHeight, 2);
+            }
+
+            //Generate inner Walls according to levelcode
+            for(int y=0; y<numCells; y++){
+                for(int x=0; x<numCells; x++){
+                    switch(levelcode[ y * numCells + x ]){
+                        case 1: (new HoverWall(origin_->getContext()))->init(x+1, numCells-y, cellSize, cellHeight, 1);
+                                break;
+                        case 3: (new HoverWall(origin_->getContext()))->init(x+1, numCells-y, cellSize, cellHeight, 1);
+                        case 2: (new HoverWall(origin_->getContext()))->init(x+1, numCells-y, cellSize, cellHeight, 0);
+                        default: break;
+                    }
+                }   
+            }
+
+            //Generate 5 flags randomly
+            for ( int i = 0; i < 5; i++ )
+            {
+                HoverFlag* flag = new HoverFlag(origin_->getContext());
+                flag->init(rand()%numCells, rand()%numCells, cellSize);
+                flags_.push_back(flag);
+            }
+
+        }//firsttick end
+
+        // Check if ship collided with one of the flags
+        for ( unsigned int i = 0; i < flags_.size(); i++ ){
+            if(flags_[i]->getCollided()){
+                flags_[i]->destroyLater();
+                flags_.erase (flags_.begin()+i);
+            }
+        }
+        numberOfFlags_ = flags_.size();
+    }
+}
Index: /code/trunk/src/modules/hover/Hover.h
===================================================================
--- /code/trunk/src/modules/hover/Hover.h	(revision 11052)
+++ /code/trunk/src/modules/hover/Hover.h	(revision 11052)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Master of Desaster:
+ *      Manuel Meier
+ *   Co-authors:
+ *      Cyrill Burgener
+ *
+ */
+
+/**
+    @file Hover.h
+    @brief Gametype. For more information see .cc file
+    @ingroup Hover
+*/
+
+#ifndef _Hover_H__
+#define _Hover_H__
+
+#include "HoverPrereqs.h"
+
+#include <vector>
+
+#include "gametypes/Gametype.h"
+#include "HoverOrigin.h"
+
+namespace orxonox
+{
+    class _HoverExport Hover : public Gametype
+    {
+       public:
+            Hover(Context* context);
+
+            virtual void tick(float dt);          
+
+            void setOrigin(HoverOrigin* origin)
+                { this->origin_ = origin; }
+
+            inline int getNumberOfFlags() const
+                { return this->numberOfFlags_; }
+
+        private:
+            WeakPtr<HoverOrigin> origin_;
+            std::vector<HoverFlag*> flags_;
+            int numberOfFlags_;
+            bool firstTick_;
+    };
+}
+
+#endif /* _Hover_H__ */
Index: /code/trunk/src/modules/hover/HoverFlag.cc
===================================================================
--- /code/trunk/src/modules/hover/HoverFlag.cc	(revision 11052)
+++ /code/trunk/src/modules/hover/HoverFlag.cc	(revision 11052)
@@ -0,0 +1,109 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Manuel Meier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file HoverFlag.cc
+    @brief The Flags that are being set in the Hover Minigame They support two coordinates from 0-9 each
+*/
+
+#include "HoverFlag.h"
+#include "HoverShip.h"
+
+#include "core/CoreIncludes.h"
+
+#include "graphics/Model.h"
+#include "objects/collisionshapes/BoxCollisionShape.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(HoverFlag);
+
+    HoverFlag::HoverFlag(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(HoverFlag);
+
+        this->model_ = NULL;
+        this->cs_ = NULL;
+        this->collided_ = false;
+
+        this->enableCollisionCallback();
+        this->setCollisionResponse(true);
+        this->setCollisionType(Static);
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    HoverFlag::~HoverFlag()
+    {
+        if (this->isInitialized())
+        {
+            if (this->model_)
+                this->model_->destroy();
+            if (this->cs_)
+                this->cs_->destroy();
+        }
+    }
+
+    /**
+    @brief
+        Initializes the flag.
+    @param xCoordinate
+        X-Coordinate of the flage, 0-9, origin is bottom left
+    @param yCoordinate
+        Y-Coordinate of the flage, 0-9, origin is bottom left
+    */
+    void HoverFlag::init(int xCoordinate, int yCoordinate, int cellSize)
+    {
+        model_ = new Model(this->getContext());
+        model_->setMeshSource("ss_flag_eu.mesh");
+        model_->setScale3D(Vector3(5, 5, 5));
+        model_->setPosition(Vector3(xCoordinate*cellSize*1.0f + cellSize/2,10.0f,yCoordinate*cellSize*1.0f + cellSize/2));
+
+        this->attach(model_);
+
+        cs_ = new BoxCollisionShape(this->getContext());
+        cs_->setHalfExtents(Vector3(5, 5, 5));
+        cs_->setPosition(Vector3(xCoordinate*cellSize*1.0f + cellSize/2,0.0f,yCoordinate*cellSize*1.0f + cellSize/2));
+
+        this->attachCollisionShape(cs_);
+    }
+
+    /**
+    @brief
+        Checks if the Hovership collided with the flag
+    */
+    bool HoverFlag::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint)
+    {
+        if(otherObject->isA(Class(HoverShip)))
+            collided_ = true;
+        return false;
+    }
+}
Index: /code/trunk/src/modules/hover/HoverFlag.h
===================================================================
--- /code/trunk/src/modules/hover/HoverFlag.h	(revision 11052)
+++ /code/trunk/src/modules/hover/HoverFlag.h	(revision 11052)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Manuel Meier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file HoverFlag.h
+    @brief See .cc File
+    @ingroup Hover
+*/
+
+#ifndef _HoverFlag_H__
+#define _HoverFlag_H__
+
+#include "HoverPrereqs.h"
+#include "objects/ObjectsPrereqs.h"
+
+#include "worldentities/StaticEntity.h"
+
+namespace orxonox
+{
+    class _HoverExport HoverFlag : public StaticEntity
+    {
+        public:
+            HoverFlag(Context* context);
+            virtual ~HoverFlag();
+
+            void init(int xCoordinate, int yCoordinate, int cellSize);
+
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint);            
+
+            inline bool getCollided() const
+                { return this->collided_; }
+            inline void setCollided(bool setValue)
+                { this->collided_ = setValue; }
+
+        private:
+            Model* model_;
+            BoxCollisionShape* cs_;
+            bool collided_;
+
+    };
+}
+
+#endif /* _HoverFlag_H__ */
Index: /code/trunk/src/modules/hover/HoverOrigin.cc
===================================================================
--- /code/trunk/src/modules/hover/HoverOrigin.cc	(revision 11052)
+++ /code/trunk/src/modules/hover/HoverOrigin.cc	(revision 11052)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Manuel Meier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file HoverOrigin.cc
+    @brief The HoverOrigin is a StaticEntity which represents the level of the minigame. All platforms, enemies and items are attached to the HoverOrigin.
+*/
+
+#include "HoverOrigin.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "Hover.h"
+
+namespace orxonox
+{
+    RegisterClass(HoverOrigin);
+
+    HoverOrigin::HoverOrigin(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(HoverOrigin);
+        checkGametype();
+    }
+
+    void HoverOrigin::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(HoverOrigin, XMLPort, xmlelement, mode);
+
+        XMLPortParam(HoverOrigin, "numCells", setNumCells, getNumCells, xmlelement, mode);
+        XMLPortParam(HoverOrigin, "cellSize", setCellSize, getCellSize, xmlelement, mode);
+        XMLPortParam(HoverOrigin, "cellHeight", setCellHeight, getCellHeight, xmlelement, mode);
+    }
+
+    void HoverOrigin::checkGametype()
+    {
+        if (getGametype() != NULL && this->getGametype()->isA(Class(Hover)))
+        {
+            Hover* hoverGametype = orxonox_cast<Hover*>(this->getGametype());
+            hoverGametype->setOrigin(this);
+        }
+    }
+}
